Unit IDS2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IDS2R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real);

implementation

procedure IDS2R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y2 :Array of Real;
                var F :Array of Real; var G :Array of Real);
var
N1,J1,J2,K :Integer;
H1,H2,R1,R2,Z :Real;
label
_1,_2,_3,_4;
begin
N1 := N-1;
J1 := 1;
H1 := 0.0;
F[0] := 0.0;
G[0] := 0.0;
R1 := Y2[0];
for K:=1 to N do
 begin
  if ( K <= N1 ) 
   then goto _1;
  H2 := 0.0;
  R2 := Y2[N-1];
  goto _2;
_1:
  J2 := K+1;
  H2 := X[J2-1]-X[K-1];
  R2 := (Y[J2-1]-Y[K-1])/H2;
_2:
  Z := 1.0/(2.0*(H1+H2)-H1*G[J1-1]);
  G[K-1] := Z*H2;
  F[K-1] := Z*(6.0*(R2-R1)-H1*F[J1-1]);
  J1 := K;
  H1 := H2;
  R1 := R2;
_3:
 end;
Y2[N-1] := F[N-1];
for J1:=1 to N1 do
 begin
  K := N-J1;
  Y2[K-1] := F[K-1]-G[K-1]*Y2[K+0];
_4:
 end;
end;

end.
